/*****************************************************

     EchoChr.c
     Z-World, 1999

     This program echos characters over serial port B.
     It must be run with a serial utility such as Hyperterminal.
     
     Connect RS232 cable from PC to Rabbit:
     	 Connect PC's RS232 GND to Rabbit GND
       Connect PC's RS232 TD  to Rabbit RXB
       Connect PC's RS232 RD  to Rabbit TXB
       
     Configure the serial utility for port connected to RS232, 19200 8N1.
     
     Run this program.
     Run Hyperterminal.
     Type characters into the serial utility window.
      
     This program will echo characters sent from the serial utility back to 
     the serial utility where they will appear in its send/receive window.
     
******************************************************/

/*****************************************************
     The input and output buffers sizes are defined here. If these
     are not defined to be (2^n)-1, where n = 1...15, or they are
     not defined at all, they will default to 31 and a compiler
     warning will be displayed.
******************************************************/
#define BINBUFSIZE  15
#define BOUTBUFSIZE 15

xmem main()
{
   int c;
	c = 0;
   serBopen(19200);
   while (c != 27) {  // Exit on Esc
      if ((c = serBgetc()) != -1 && c != 27) { 
         	serBputc(c);
      }
   }
   serBputs("Done");
   while (serBwrFree() != BOUTBUFSIZE) ;      // allow transmission to complete before closing
   serBclose();
}